﻿function GetRallyingcried_OnLoad()
	GetRallyingcriedFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	-- Slash Commands
	SlashCmdList["GetRallyingcried"] = GetRallyingcried_SlashCommands
	SLASH_GetRallyingcried1 = "/gr"
	SLASH_GetRallyingcried2 = "/getrallyingcried"
end

-- Default Settings
if GR_Party == nil then
	GR_Party = true
end
if GR_Raid == nil then
	GR_Raid = true
end
if GR_PartyInstance == nil then
	GR_PartyInstance = true
end
if GR_RaidInstance == nil then
	GR_RaidInstance = true
end
if GR_Arena == nil then
	GR_Arena = true
end
if GR_Battleground == nil then
	GR_Battleground = true
end

-- Message Format
local MessageFormat = "%s %s."

-- Channels
local BattlegroundChannel		= "INSTANCE_CHAT"
local ArenaChannel				= "INSTANCE_CHAT"
local RaidInstanceChannel		= "INSTANCE_CHAT"
local PartyInstanceChannel		= "INSTANCE_CHAT"
local RaidChannel				= "RAID"
local PartyChannel				= "PARTY"

function GetRallyingcried_OnEvent(self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local eventType, sourceGUID, destGUID, id
		if select(4, GetBuildInfo()) >= 50100 then
			BattlegroundChannel = "INSTANCE_CHAT"
			ArenaChannel = "INSTANCE_CHAT"
			RaidInstanceChannel = "INSTANCE_CHAT"
			PartyInstanceChannel = "INSTANCE_CHAT"
			eventType, sourceGUID, destGUID, id = select(2, ...), select(4, ...), select(8, ...), select(12, ...)
		elseif select(4, GetBuildInfo()) >= 40200 then
			BattlegroundChannel = "BATTLEGROUND"
			ArenaChannel = "PARTY"
			RaidInstanceChannel = "RAID"
			PartyInstanceChannel = "PARTY"
			eventType, sourceGUID, destGUID, id = select(2, ...), select(4, ...), select(8, ...), select(12, ...)
		elseif select(4, GetBuildInfo()) >= 40100 then
			BattlegroundChannel = "BATTLEGROUND"
			ArenaChannel = "PARTY"
			RaidInstanceChannel = "RAID"
			PartyInstanceChannel = "PARTY"
			eventType, sourceGUID, destGUID, id = select(2, ...), select(4, ...), select(7, ...), select(10, ...)
		elseif select(4, GetBuildInfo()) >= 40000 then
			BattlegroundChannel = "BATTLEGROUND"
			ArenaChannel = "PARTY"
			RaidInstanceChannel = "RAID"
			PartyInstanceChannel = "PARTY"
			eventType, sourceGUID, destGUID, id = select(2, ...), select(3, ...), select(6, ...), select(9, ...)
		elseif select(4, GetBuildInfo()) >= 20400 then
			BattlegroundChannel = "BATTLEGROUND"
			ArenaChannel = "PARTY"
			RaidInstanceChannel = "RAID"
			PartyInstanceChannel = "PARTY"
			eventType, sourceGUID, destGUID, id = select(2, ...), select(3, ...), select(6, ...), select(9, ...)
		end

		if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and IsInInstance() then
			if select(2, IsInInstance()) == "pvp" then
				if GR_Battleground == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, BattlegroundChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, BattlegroundChannel)
						end
					end
				end
			elseif select(2, IsInInstance()) == "arena" then
				if GR_Arena == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, ArenaChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, ArenaChannel)
						end
					end
				end
			elseif select(2, IsInInstance()) == "raid" then
				if GR_RaidInstance == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, RaidInstanceChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, RaidInstanceChannel)
						end
					end
				end
			elseif select(2, IsInInstance()) == "party" then
				if GR_PartyInstance == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, PartyInstanceChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, PartyInstanceChannel)
						end
					end
				end
			elseif select(2, IsInInstance()) == nil then
				if GR_PartyInstance == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, PartyInstanceChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, PartyInstanceChannel)
						end
					end
				end
			end
		else
			if IsInRaid() == true then
				if GR_Raid == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, RaidChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, RaidChannel)
						end
					end
				end
			elseif GetNumSubgroupMembers() ~= nil and GetNumSubgroupMembers() > 0 then
				if GR_Party == true then
					if eventType == "SPELL_AURA_APPLIED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Used)
							SendChatMessage(Message, PartyChannel)
						end
					elseif eventType == "SPELL_AURA_REMOVED" then
						if id == 97463 and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("player") then
							local Message = format(MessageFormat, GetSpellLink(id), GR_Faded)
							SendChatMessage(Message, PartyChannel)
						end
					end
				end
			end
		end
	end
end

function GetRallyingcried_SlashCommands(arg1)
	local arg1 = string.lower(arg1)
	if arg1 == "" then
		GetRallyingcried_PrintSlashMenu()
	elseif arg1 == "party" then
		GR_Party = not GR_Party
		if GR_Party == true then
			print("|cFF50C0FF"..GR_Opt_Party..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GR_Opt_Party..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "raid" then
		GR_Raid = not GR_Raid
		if GR_Raid == true then
			print("|cFF50C0FF"..GR_Opt_Raid..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GR_Opt_Raid..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "partyinstance" or arg1 == "party instance" or arg1 == "partyi" then
		GR_PartyInstance = not GR_PartyInstance
		if GR_PartyInstance == true then
			print("|cFF50C0FF"..GR_Opt_PartyInstance..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GR_Opt_PartyInstance..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "raidinstance" or arg1 == "raid instance" or arg1 == "raidi" then
		GR_RaidInstance = not GR_RaidInstance
		if GR_RaidInstance == true then
			print("|cFF50C0FF"..GR_Opt_RaidInstance..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GR_Opt_RaidInstance..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "arena" then
		GR_Arena = not GR_Arena
		if GR_Arena == true then
			print("|cFF50C0FF"..GR_Opt_Arena..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GR_Opt_Arena..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
		end
	elseif arg1 == "battleground" or arg1 == "bg" then
		GR_Battleground = not GR_Battleground
		if GR_Battleground == true then
			print("|cFF50C0FF"..GR_Opt_Battleground..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
		else
			print("|cFF50C0FF"..GR_Opt_Battleground..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
		end
	else
		GetRallyingcried_PrintSlashHelp()
	end
end

function GetRallyingcried_PrintSlashHelp()
	print("|cFFFFA500GetRallyingcried "..GetAddOnMetadata("GetRallyingcried", "Version").." "..GR_Opt_CmdList.."|cFFFFFFFF")
	print("|cFF50C0FF/gr - |cFFFFFFA0"..GR_Opt_HelpStatus.."|cFFFFFFFF")
	print("|cFF50C0FF/gr party - |cFFFFFFA0"..GR_Opt_HelpParty.."|cFFFFFFFF")
	print("|cFF50C0FF/gr raid - |cFFFFFFA0"..GR_Opt_HelpRaid.."|cFFFFFFFF")
	print("|cFF50C0FF/gr partyi - |cFFFFFFA0"..GR_Opt_HelpPartyInstance.."|cFFFFFFFF")
	print("|cFF50C0FF/gr raidi - |cFFFFFFA0"..GR_Opt_HelpRaidInstance.."|cFFFFFFFF")
	print("|cFF50C0FF/gr arena - |cFFFFFFA0"..GR_Opt_HelpArena.."|cFFFFFFFF")
	print("|cFF50C0FF/gr bg - |cFFFFFFA0"..GR_Opt_HelpBattleground.."|cFFFFFFFF")
end

function GetRallyingcried_PrintSlashMenu()
	print("|cFFFFA500GetRallyingcried "..GetAddOnMetadata("GetRallyingcried", "Version").." "..GR_Opt_HelpInput.."|cFFFFFFFF")
	if GR_Party == true then
		print("|cFF50C0FF"..GR_Opt_Party..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GR_Opt_Party..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
	end
	if GR_Raid == true then
		print("|cFF50C0FF"..GR_Opt_Raid..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GR_Opt_Raid..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
	end
	if GR_PartyInstance == true then
		print("|cFF50C0FF"..GR_Opt_PartyInstance..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GR_Opt_PartyInstance..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
	end
	if GR_RaidInstance == true then
		print("|cFF50C0FF"..GR_Opt_RaidInstance..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GR_Opt_RaidInstance..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
	end
	if GR_Arena == true then
		print("|cFF50C0FF"..GR_Opt_Arena..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GR_Opt_Arena..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
	end
	if GR_Battleground == true then
		print("|cFF50C0FF"..GR_Opt_Battleground..": |cFFADFF2F"..GR_Opt_Enable.."|cFFFFFFFF")
	else
		print("|cFF50C0FF"..GR_Opt_Battleground..": |cFFFF4500"..GR_Opt_Disable.."|cFFFFFFFF")
	end
end